/*
* jQuery Arfaly Plugin; v20141015
* http://www.itechflare.com/
* Copyright (c) 2014 iTechFlare; Licensed: Commercial
* Version : v1.5.6
* Developer: Abdulrhman Elbuni (mindsquare)
*/

jQuery.noConflict();
 
(function( $ ) {

    // The Arfaly plugin
	$.fn.arfaly = function(options) {
 
		var mainNode = this;
		var gIndex=0;
		var mimeImage;
		
		// The module pattern
		var arfaly = {
			init: function() {
				arfaly.config = $.extend({
						allowedFileSize: 1024 * 1024 * 10, // (10 MB)
						delay:5000,
						multi:true,
						url: "processMultipleUploads.php",
						dataType: "json",
						limitNumberofFiles:10,
						label:'Allowed file types are gif, jpg, png, avi, mp3, wav, mp4, doc, docx, pdf, txt, zip and rar.',
						labelColor:'rgb(90, 90, 90)',
						debug:false,
						dragDrop:true,
						targetOutput:'.output',
						type: "post",
						disablePostProgressAnimation:true,
						disableRemovingItems:true,
						logoColor:'rgb(150, 155, 255)',
						textColor:'#DADADA',
						progressBarColor: 'orange',
						action:'itech_arfaly_submission',
						beforeSubmit:  arfaly.beforeSubmit,
						successfulUpload: arfaly.successfulUpload,
						failedUpload: arfaly.failedUpload,
						fileDeleted: arfaly.fileDeleted
					}, options );
					
				arfaly.Setup();
				$(arfaly.config.targetOutput).hide();
			},
			Setup: function() {
				var multiElm = '';
				var hiddenInputStyle = '';
				
				if(arfaly.config.multi)
				{
					multiElm = 'multiple';
				}
				
				if(arfaly.config.dragDrop)
				{
					hiddenInputStyle = 'display:none';
				}
				
				var wpSecurity = '<input type="hidden" name="action" value="itech_mass_upload_submission" />';
				var label = '<p class="arfaly-label" style="color:'+arfaly.config.labelColor+'">'+arfaly.config.label+'</p>';
				var uploadInputs = '<div><div id="arfaly-filedrag" style="color: '+arfaly.config.textColor+';border: 9px dashed '+arfaly.config.textColor+';"><span class="arfaly-showcase icon icon-cloud-storage" style="color:'+arfaly.config.logoColor+'"></span><br/>Drop files here</div><br/>'+label+'</div>';
				var uploadHiddenInput = '<input type="file" style="'+hiddenInputStyle+'" name="files[]" id="'+mainNode.attr("id")+'-arfaly-files" '+multiElm+'><br/>';
				var shiftDown = '<br/>';
				var arfalyListItem = '<div id="'+mainNode.attr('id')+'-ListItem" class="arfaly-multi-images"></div>';
				mainNode.addClass('arfaly-multiple-upload');
				
				if(arfaly.config.dragDrop)
				{
					mainNode.html( wpSecurity + uploadInputs + uploadHiddenInput + arfalyListItem ) ;
				}else{
					mainNode.html( wpSecurity + uploadHiddenInput + shiftDown + label + arfalyListItem ) ;
				}
			},
			bytesToSize:function(bytes) {
			   var sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB'];
			   if (bytes == 0) return '0 Bytes';
			   var i = parseInt(Math.floor(Math.log(bytes) / Math.log(1024)));
			   return Math.round(bytes / Math.pow(1024, i), 2) + ' ' + sizes[i];
			},
			successfulUpload:function(result)
			{// Handle event
			},
			failedUpload:function(result)
			{// Handle event
			},
			fileDeleted:function(data)
			{			
				var indx = data.fileIdx;
				// Send delete request
				$.ajax({
					url:arfaly.config.url,
					type: "POST",
					data: data,
					success: function( data ) {
						// Handle successful delete
						outputMessage(data);
					}
				});
			},
			beforeSubmit: function(file, indx)
			{
				var is_chrome = navigator.userAgent.indexOf('Chrome') > -1;
				var is_safari = navigator.userAgent.indexOf("Safari") > -1;
				if ((is_chrome)&&(is_safari)) {is_safari=false;}

				//check whether browser fully supports all File API
			   if (window.File && window.FileReader && window.FileList && window.Blob)
				{					
					var fsize = file.size; //get file size
					var ftype = file.type; // get file type

					//allow only valid MIME file types 
					switch(ftype)
					{
						case 'image/png':case 'image/gif':case 'image/jpeg':case 'image/pjpeg':case 'image/x-png':case 'image/jpg': // images
							mimeImage = "icon-photo";
							break;
						case 'audio/aac':case 'audio/mp4':case 'audio/mp3':case 'audio/ogg':case 'audio/wav':case 'audio/webm': // Audio
							mimeImage = "icon-music";
							break;
						case 'video/mp4':case 'video/ogg':case 'video/webm':case 'video/avi':case 'video/mkv':case 'video/x-matroska': // Video
							mimeImage = "icon-video2";
							break;
						case 'application/x-zip-compressed':case 'application/zip':case 'application/octet-stream':case 'application/x-rar-compressed':case 'application/octet-stream':
							mimeImage = "icon-wallet";
							break;
						default:
							mimeImage = "icon-file";
					}
					
					//Allowed file size is less than 1 MB (1048576)
					if(fsize > arfaly.config.allowedFileSize ) 
					{
                        var data = [];
						data.status = false;
                        data.responseText = arfaly.bytesToSize(fsize) +": The file size has exceeded the limit ("+arfaly.config.allowedFileSize/1024/1024+"MB) !";

						return data;
					}
							
					var data = [];
					data.status = true;
					return data;
				}
				else
				{
					var data = [];
					data.status = true;
					if(is_safari) data;
					
					
					//Output error to older unsupported browsers that doesn't support HTML5 File API
					data.status = false;
					data.responseText = "Please upgrade your browser, because your current browser lacks some new features we need!";
					return data;
				}
				
				var data = [];
				data.status = true;
				return data;
			},
			deleteItem: function(indx)
			{
				var data ={
					 'arfaly-id':mainNode.attr('id'),
					 'command':'delete',
					 'arfaly-filename':mainNode.find('#'+indx+'-fileName').text(),
					 'fileIdx':indx
					};
				// Trigger delete event
				arfaly.config.fileDeleted(data);
				
				$("#uploadItem-"+indx).addClass("animated bounceOutRight");
				setTimeout( function(e){
					$("#uploadItem-"+indx).remove();
				}, 600 );
			},
			addFileItem: function(fileName, indx)
			{		
				var hiddenInput = '<input type="hidden" id="file-'+indx+'-'+mainNode.attr("id")+'" name="image-id[]" value="" />';
				var infoBox = '<div id="arfaly-info-box-'+indx+'" class="info-box noselect"><div class="arfaly-info-p"><a class="close" index="'+indx+'"><span class="arfaly-info-close icon icon-delete"></span></a><div class="arfaly-info-internal-content">Everything going well so far!</div></div><div class="arfaly-pointer"></div></div>';
				var infoIcon = '<a class="info-icon" index="'+indx+'"><span class="arfaly-info-icon icon icon-info" ></span></a>';
				var uploadListItem = infoBox+'<div id="uploadItem-'+indx+'"><div class="arfaly-oval"><span class="arfaly-loading icon icon-spinner"></span><div id="mass-item-success-'+indx+'" class="notification-oval"><ul class="arfaly-oval-list-info" id="mass-item-oval-info-'+indx+'"><li id="mass-item-success-text-'+indx+'" style=";color:white;font-family:cursive;font-size:10px;color:white"></li></li></div></div><div class="arfaly-list-div noselect">'+hiddenInput+'<div><div class="arfaly-list-icon arfaly-left"><span id="mimePicture" class="icon" style="font-size:40px"></span></div><div class="progress-container arfaly-right"><div id="progress-style-'+indx+'" class="arfaly-meter '+arfaly.config.progressBarColor+' arfaly-right"><span id="massUploadProgress-'+indx+'" style="width: 0%;" class="arfaly-span-progress"></span></div><span id="'+indx+'-fileName" style="z-index: 5;position: relative;font-size: 9px;font-family: cursive;color:#fff;">'+fileName+'</span><div class="arfaly-list-menu arfaly-right"><ul><li><a class="delete" id="'+indx+'"><span class="icon icon-remove" title="Delete this file"></span></a>&nbsp;<a rel="external" link="" id="preview-'+indx+'" index="'+indx+'" class="preview"><span class="icon icon-earth" title="Preview file"></span></a></li></ul></div></div>'+infoIcon+'</div></div></div>';
				
				$('#'+mainNode.attr('id')+'-ListItem').prepend(uploadListItem);
				
				var diff = $('.arfaly-oval').height()-$('#mass-item-success-'+indx).height();
				$('#mass-item-success-'+indx).css('margin-top',(diff/2)+'px');
				
				// Click delete handler
				$('#uploadItem-'+indx).find('a.delete').click(function(){
					var confirmation = confirm("Are you sure you want to delete the file?");
					if(confirmation)
					{
						var indx = $(this).attr('id');
						arfaly.deleteItem(indx);
					}
				});
				
				// Info icon click event handler
				$('#uploadItem-'+indx).find('a.info-icon').click(function(e){
					var offset = $(this).offset();
					var indx = $(this).attr('index');
					if($(window).width() < 400)
					{
						$('#arfaly-info-box-'+indx).css('top',(offset.top-28)+'px');
						$('#arfaly-info-box-'+indx).css('left',(offset.left+19)+'px');
						$('#arfaly-info-box-'+indx).slideDown();
					}else{
						$('#arfaly-info-box-'+indx).css('top',(offset.top+33)+'px');
						$('#arfaly-info-box-'+indx).css('left',(offset.left-20)+'px');
						$('#arfaly-info-box-'+indx).slideDown();
					}
				});
				// Info-box close click event handler
				$('#arfaly-info-box-'+indx).find('a.close').click(function(e){
					var indx = $(this).attr('index');
					$('#arfaly-info-box-'+indx).slideUp();
				});
				$(document).mouseup(function (e)
				{
					var container = $('.info-box');

					if (!container.is(e.target) // if the target of the click isn't the container...
						&& container.has(e.target).length === 0) // ... nor a descendant of the container
					{
						container.hide();
					}
				});
				
				// Click preview handler
				$('#uploadItem-'+indx).find('a.preview').on('click', function(){
					var indx = $(this).attr('index');
					if($('#preview-'+indx).attr('link') != ""){
						window.open(document.URL+$('#preview-'+indx).attr('link'),'_blank');
					}
				});
				// Fixed iOS problem
				$('div.arfaly-list-div').click(function(e){
					e.preventDefault();
				});
			},
			tagItemSuccess: function(indx, success, msg)
			{
				$('#uploadItem-'+indx).find('.arfaly-loading').hide();
				var successTag;
				if(!success)
				{	
					successTag = '<li class="icon icon-times center-icon" style="font-size:30px;color:white"></li>';
					CatchError(indx, msg);
				}else{
					successTag = '<li class="icon icon-tick center-icon" style="font-size:30px;color:white"></li>';
				}
				
				if($("#mass-item-success-"+indx).attr('updated') != "true")
				{
					$("#mass-item-oval-info-"+indx).prepend(successTag);
					$("#mass-item-success-"+indx).attr("title",msg);
					$("#uploadItem-"+indx).attr("title",msg);
					$("#mass-item-success-"+indx).addClass('animated '+(success?'flipNotificationSuccess':'flipNotificationError'));
					$("#mass-item-success-text-"+indx).html((success?'Succeed':'Failed'));
					$("#mass-item-success-"+indx).attr('updated','true');
					outputMessage(msg);
				}
			},
			fileDragHover: function(e)
			{
				e.stopPropagation();
				e.preventDefault();
				
				mainNode.find("#arfaly-filedrag").removeClass("hover").addClass((e.type == "dragover" ? "hover" : ""));
			}
		};
		
		// Initialization
		arfaly.init();
		
		var	filedrag = mainNode.find("#arfaly-filedrag");
		
		// file drop
		filedrag.on('dragover', arfaly.fileDragHover);
		filedrag.on('dragleave', arfaly.fileDragHover);
		filedrag.on('drop', fileSelectHandler);
		filedrag.css('display', 'block');
		
		function CatchError(indx, msg)
		{
			$('#arfaly-info-box-'+indx).find('.arfaly-info-internal-content').html(msg);
		}
		
		// click sidebar
		filedrag.click(function(){
			$("input[id="+mainNode.attr("id")+"-arfaly-files]").click();
		});
		
		function outputMessage(str)
		{
			if(arfaly.config.debug){
				if($(arfaly.config.targetOutput).is(":visible"))
				{
					$(".output-list-"+mainNode.attr("id")).append('<li>'+str+'</li>');
				}else{
					$(arfaly.config.targetOutput).html('<br><ol class="output-list-'+mainNode.attr("id")+'"><li>'+str+'</li></ol>');
					$(arfaly.config.targetOutput).delay(300).slideDown();
				}
			}
		}
		
		function fileSelectHandler(e)
		{
			e.stopPropagation();
			e.preventDefault();
			
			mainNode.find("#arfaly-filedrag").removeClass('hover').addClass('');

			// fetch FileList object
			var files = e.target.files || e.originalEvent.dataTransfer.files;

			// process all File objects
			processFiles(files);
		}
		
		function processFiles(inputFiles)
		{
			var files = inputFiles;
			var j=0;
			var request = [];
			
			for(j;j<files.length;j++)
			{
				if(gIndex>=arfaly.config.limitNumberofFiles)
				{	
					outputMessage('You have exceed upload limit ('+gIndex+') !');
					return false;
				}
				
				if(files[j].length == 0){
					continue;
				}

				var data = new FormData();
				data.append('SelectedFile', files[j]);
				data.append('action', JSON.stringify( arfaly.config.action, null, 2));

				arfaly.addFileItem(files[j].name,gIndex);
				var sanitizeFile = arfaly.beforeSubmit(files[j], gIndex);
				
				// Update mime picture
				if(mimeImage == null )
				{
					$('#uploadItem-'+gIndex).find('#mimePicture').addClass('icon-file');
				}
				else
				{
					$('#uploadItem-'+gIndex).find('#mimePicture').addClass(mimeImage);
				}	

				if(sanitizeFile.status!=true)
				{
					// Catch errors
					arfaly.tagItemSuccess(gIndex,false, sanitizeFile.responseText);
					gIndex++;
					continue;
				}

				var requestTemp = new XMLHttpRequest();
				request[j] = requestTemp;
				request[j].index = gIndex;
				request[j].onreadystatechange = function(){
					if(this.readyState == 4){
						try {
							var resp = JSON.parse(this.response);

							if(resp.status == "true")
							{
								arfaly.tagItemSuccess(this.index,true, resp.msg);

								if(resp.newFileName != null)
								{
									// Update filename
									$('#'+this.index+'-fileName').text(resp.newFileName);
								}
								if(resp.fullPath != null)
								{
									// Update preview path
									$('#preview-'+this.index).attr('link',resp.fullPath);
								}
								if(arfaly.config.disablePostProgressAnimation == true){
									mainNode.find('#progress-style-'+this.index).addClass('nostripes');
								}
								// Trigger a successful upload event
								arfaly.config.successfulUpload(resp);
							}else{
								arfaly.tagItemSuccess(this.index,false, resp.msg);
								
								// Trigger a failed upload event
								arfaly.config.failedUpload(resp);
								CatchError(this.index, resp.msg);
							}
						} catch (e){
							// Handle errors 
							var resp = {
								status: 'error',
								msg: 'Response string format is not a valid JSON: [' + this.responseText + ']'
							};
							// Uploading failed
							arfaly.tagItemSuccess(this.index,false, resp.msg);
						}
					}
				};
				
				request[j].upload.index = gIndex;
				
				// Progress event listener
				request[j].upload.addEventListener('progress', function(e){
					var progress = e.loaded/e.total * 100;
					var index = this.index;
				
					$("#massUploadProgress-"+this.index).css( "width", progress + '%');
					if(progress >= 100 && !arfaly.config.disableRemovingItems)
					{
						setTimeout( function(e){
							arfaly.deleteItem(index);
						}, arfaly.config.delay );
					}
				}, false);

				request[j].open(arfaly.config.type, arfaly.config.url);
				request[j].send(data);
				gIndex++;
			}
		}

		// File choosen - event
		this.find("input[type=file]").change(function (){
			processFiles(this.files);
		});
	};
	
})(jQuery);